package com.vserrano.photos_share;

import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.util.Log;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

public class OpcionesBD {

    private static BaseDatos bdTemp;
    private static String tag = "PhotosShare";

    public OpcionesBD(Context context) {
        bdTemp = new BaseDatos(context);
    }

    public static void indicializaBD(Context contexto){
        bdTemp = new BaseDatos(contexto);
    }

    public static void NuevoUsuario(String cuenta) {
        SQLiteDatabase bd = bdTemp.getWritableDatabase();
        long fechaalta = System.currentTimeMillis();
        String[] parts = cuenta.split("@");
        bd.execSQL("INSERT INTO Usuarios (usuario,contra,falta,alias,calidad_imagen) VALUES ( '" + cuenta + "','1234','"+ fechaalta +"','"+parts[0]+ "',2) ");
        bd.close();
    }

    public static int BuscarUsuario(String cuenta) {
        int id = -1;
        SQLiteDatabase bd = bdTemp.getReadableDatabase();
        Cursor c = bd.rawQuery("SELECT * FROM Usuarios WHERE usuario='"+cuenta+"'", null);
        if (c.moveToNext()){
            id = c.getInt(0);
        }
        c.close();
        bd.close();
        return id;
    }

    public static String BuscarAlias(String usuario){
        String alias="";
        SQLiteDatabase bd = bdTemp.getReadableDatabase();
        Cursor c = bd.rawQuery("SELECT alias FROM Usuarios WHERE usuario='"+usuario+"'", null);
        if (c.moveToNext()){
            alias = c.getString(c.getColumnIndex("alias"));
        }
        c.close();
        bd.close();
        return alias;
    }
    public static String BuscarFilename(String imgoriginal){
        String Filename="";
        SQLiteDatabase bd = bdTemp.getReadableDatabase();
        Cursor c = bd.rawQuery("SELECT filename FROM Imagenes WHERE imgoriginal='"+imgoriginal+"'", null);
        if (c.moveToNext()){
            Filename = c.getString(c.getColumnIndex("filename"));
        }
        c.close();
        bd.close();
        return Filename;
    }
    public static String BuscarRutaFotoPerfil(String usuario){
        String foto="";
        Log.e("Valores BD: ", usuario);

        SQLiteDatabase bd = bdTemp.getReadableDatabase();
        Cursor c = bd.rawQuery("SELECT foto FROM Usuarios WHERE usuario='"+usuario+"'", null);
        if (c.moveToNext()){
            foto = c.getString(c.getColumnIndex("foto"));
        }
        c.close();
        bd.close();
        if (foto!=null) {
            if (foto.length() > 1) {
                return foto;
            } else {
                return "-";
            }
        }else{
            return "-";
        }
    }

    public static List<ImagenDrive> MostrarImagenesDrive() {
        List<ImagenDrive> imagenes = new ArrayList<ImagenDrive>();
        ImagenDrive imgdrive = null;

        SQLiteDatabase bd = bdTemp.getReadableDatabase();
        //*********************************
        //TODO Obtener todas las imagenes
        Cursor result = bd.rawQuery("SELECT filename,falta,imgmini,imgoriginal FROM Imagenes where imgmini is not null order by fsincronizar asc",null);
        result.moveToFirst();
        //Recorrer toda la tabla
        while(!result.isAfterLast()) {
            Log.e(tag,"MostrarImagenesDrive: "+result.getString(0));

            imgdrive = new ImagenDrive();
            imgdrive.setFilename(result.getString(2));//Mostramos el numero de la imagen
            imgdrive.setComentario(result.getString(1));//oculto

            imgdrive.setUrl_img("https://drive.google.com/thumbnail?authuser=0&sz=s220&id="+result.getString(3));
            imgdrive.setIdfichero(result.getString(3));
            imagenes.add(imgdrive);
            result.moveToNext();
        }
        result.close();
        //***********************************
        bd.close();

        return imagenes;
    }

    public static void ActualizarListaFotos(String Filename, String ThumbnailLink, String IdFile){
        String imagenbuscar="";
        long fechaactual = System.currentTimeMillis();

        SQLiteDatabase bd = bdTemp.getReadableDatabase();

        Cursor buscar = bd.rawQuery("SELECT imgoriginal FROM Imagenes WHERE imgoriginal='"+IdFile+"'", null);
        if (buscar.moveToNext()){
            imagenbuscar = buscar.getString(buscar.getColumnIndex("imgoriginal"));
        }
        buscar.close();
        //Si encuentra actualiza sino realizo el insert
        if (imagenbuscar!=null) {
            if (imagenbuscar.length() > 1) {
                bd.execSQL("UPDATE Imagenes SET imgoriginal = '"+ IdFile +"', imgmini=' "+ ThumbnailLink + "', fsincronizar='"+ fechaactual +
                        "' WHERE imgoriginal = '" + IdFile+"'");

            } else {
                bd.execSQL("INSERT INTO Imagenes (imgoriginal,imgmini,filename,falta,fsincronizar,fbaja) VALUES ( '" + IdFile +"','"+ ThumbnailLink +"','"+Filename+"','"+fechaactual+"','"+fechaactual+"',"+null+ ") ");
            }
        }else{
            bd.execSQL("INSERT INTO Imagenes (imgoriginal,imgmini,filename,falta,fsincronizar,fbaja) VALUES ( '" + IdFile +"','"+ ThumbnailLink +"','"+Filename+"','"+fechaactual+"','"+fechaactual+"',"+null+ ") ");
        }
        bd.close();

    }
    public static void ActualizarFilename(String imgoriginal,String filename){
        SQLiteDatabase bd = bdTemp.getWritableDatabase();

        bd.execSQL("UPDATE Imagenes SET filename = '"+ filename +
                "' WHERE imgoriginal = '" + imgoriginal+"'");
        bd.close();

    }

    public static void ActualizarAlias(String alias,String usuario){
        SQLiteDatabase bd = bdTemp.getWritableDatabase();

        bd.execSQL("UPDATE Usuarios SET alias = '"+ alias +
                "' WHERE usuario = '" + usuario+"'");
        bd.close();

    }

    public static void ActualizarRutaFotoPerfil(String ruta,String usuario){
        SQLiteDatabase bd = bdTemp.getWritableDatabase();

        bd.execSQL("UPDATE Usuarios SET foto = '"+ ruta +
                "' WHERE usuario = '" + usuario+"'");
        bd.close();

    }

    public static void MarcarImagenesPHP(){
        SQLiteDatabase bd = bdTemp.getWritableDatabase();
        //Marco las imagenes subidas al php para no volver a subirlas.
        bd.execSQL("UPDATE Imagenes set sinc_php='1' where sinc_php is null");
        bd.close();

    }

    public static void AsignarCalidad(int i,String usuario) {
        SQLiteDatabase bd = bdTemp.getWritableDatabase();

        bd.execSQL("UPDATE Usuarios SET calidad_imagen = '"+ i +
                "' WHERE usuario = '" + usuario+"'");
        bd.close();
    }

    public static int ObtenerCalidad(String usuario) {
        int calidad=0;
        Log.e("Valores BD: ", usuario);

        SQLiteDatabase bd = bdTemp.getReadableDatabase();
        Cursor c = bd.rawQuery("SELECT calidad_imagen FROM Usuarios WHERE usuario='"+usuario+"'", null);
        if (c.moveToNext()){
            calidad = c.getInt(c.getColumnIndex("calidad_imagen"));
        }
        c.close();
        bd.close();

        return calidad;
    }

    public static void ResetearThumbnailLink() {
        SQLiteDatabase bd = bdTemp.getWritableDatabase();
        //Marcar todos a null
        bd.execSQL("UPDATE Imagenes SET imgmini = null WHERE 1=1");
        bd.close();
    }

    public static int ContarElementos() {
        int calidad=0;

        SQLiteDatabase bd = bdTemp.getReadableDatabase();
        Cursor c = bd.rawQuery("SELECT count(_id) as num FROM Imagenes WHERE imgmini is not null", null);
        if (c.moveToNext()){
            calidad = c.getInt(c.getColumnIndex("num"));
        }
        c.close();
        bd.close();

        return calidad;
    }

    public static JSONObject SincronizarGaleriaPHP() {
        JSONArray jsonObj = new JSONArray ();

        String FileId;
        SQLiteDatabase bd = bdTemp.getReadableDatabase();

        Cursor buscar = bd.rawQuery("SELECT imgoriginal FROM Imagenes WHERE sinc_php is null order by fsincronizar desc ", null);
        if (buscar.moveToNext()){
            do {
                FileId = buscar.getString(buscar.getColumnIndex("imgoriginal"));
                //Log.e("SincronizarGaleriaPHP", FileId);
                try {
                    JSONObject jsonAdd= new JSONObject();
                    //Añadimos al json
                    jsonAdd.put("FileId", FileId);
                    jsonObj.put(jsonAdd);
                } catch (JSONException e) {
                    e.printStackTrace();
                }

                //Log.e("Jsonadd ", jsonObj.toString());
            } while (buscar.moveToNext());
        }

        buscar.close();

        JSONObject finalobject = new JSONObject();
        try {
            finalobject.put("Imagenes", jsonObj);
        } catch (JSONException e) {
            e.printStackTrace();
        }
        return finalobject;
    }


}
